VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
' Draw an arrow head at (x2, y2) for a vector from
' (x1, y1). Draw a tail at (x1, y1). Make the barbs
' anf fletchings point at a 45 degree angle away
' from the shaft.
Private Sub DrawArrow45(ByVal pic As Object, ByVal x1 As Single, ByVal y1 As Single, ByVal x2 As Single, ByVal y2 As Single, ByVal length As Single, Optional ByVal draw_head As Boolean = True, Optional ByVal num_fletchings As Integer = 0, Optional ByVal fletching_gap As Single = 60)
Dim vx As Single
Dim vy As Single
Dim dist As Single
Dim ax As Single
Dim ay As Single
Dim barb_scale As Single
Dim i As Integer
Dim gap_dx As Single
Dim gap_dy As Single

    ' Draw the shaft.
    pic.Line (x1, y1)-(x2, y2)

    ' Find the arrow shaft unit vector.
    vx = x2 - x1
    vy = y2 - y1
    dist = Sqr(vx * vx + vy * vy)
    vx = vx / dist
    vy = vy / dist

    ' See if we need to draw multiple fletchings.
    If num_fletchings > 1 Then
        ' Get the fletching spacing vector.
        gap_dx = vx * fletching_gap
        gap_dy = vy * fletching_gap
    End If

    ' Draw the right barb.
    ax = -vy - vx
    ay = vx - vy

    ' Set the proper length.
    ax = ax * length
    ay = ay * length
    If draw_head Then pic.Line (x2, y2)-Step(ax, ay)
    For i = 0 To num_fletchings - 1
        pic.Line (x1 + i * gap_dx, y1 + i * gap_dy)-Step(ax, ay)
    Next i

    ' Find the left barb.
    ax = (vy - vx) * length
    ay = (-vx - vy) * length
    If draw_head Then pic.Line (x2, y2)-Step(ax, ay)
    For i = 0 To num_fletchings - 1
        pic.Line (x1 + i * gap_dx, y1 + i * gap_dy)-Step(ax, ay)
    Next i
End Sub
Private Sub Form_Load()
Const BARB_LEN = 180

    AutoRedraw = True

    ' Draw some arrows.
    DrawArrow45 Me, 200, 400, 2000, 1000, BARB_LEN, True, 3
    DrawArrow45 Me, 1800, 300, 200, 1900, BARB_LEN, True, 3
    DrawArrow45 Me, 300, 2400, 3200, 300, BARB_LEN, True, 4
    DrawArrow45 Me, 1000, 2400, 2700, 2400, BARB_LEN, True, 1
    DrawArrow45 Me, 3400, 700, 3400, 2600, BARB_LEN, True
End Sub
